/* vim: set sts=4 ts=4 sw=4 et nojs co=88 tw=87: */
using System;
using System.Collections.Generic;

using RoBTreeFastInt = RobbieUtilities.Algorithms.BTreeFast.BTree<int>;
using RoBTreeFastKeyDivPos = RobbieUtilities.Algorithms.BTreeFast.
    BTreePartialKeyDivPos;

/**
 *  RoBTreeFastTest:
 *      This is just a simple test, not meant to be comprehensive.
 */
namespace RobbieTests
{
    public class RoBTreeFastTest
    {
        public static void Main()
        {
            int[] arr = new int[] { 7, 8, 13, 19, 21, 30, 32, 35, 48, 57, 63, 66, 90 };
            RoBTreeFastInt btree1 = new RoBTreeFastInt(201);
            IEnumerator<int> enum1;
            int i;

            for (i = 0; i < arr.Length; i++) {
                btree1.InsertElement(arr[i]);
            }
            enum1 = btree1.GetEnumerByPartialKey(new TestPKComparer(10), 30,
                RoBTreeFastKeyDivPos.KeyBeg, RoBTreeFastKeyDivPos.KeyEnd, true);
            while (enum1.MoveNext()) {
                Console.Write("{0} ", enum1.Current);
            }
            Console.WriteLine();
        }

        public class TestPKComparer : IComparer<int>
        {
            private int m_divisor;

            public TestPKComparer(int divisor)
            {
                m_divisor = divisor;
            }

            public int Compare(int oa, int ob)
            {
                return (oa / m_divisor).CompareTo(ob / m_divisor);
            }
        }
    }
}
